#include "ListenThread.h"

#include <XPLMDefs.h>
#include <XPLMUtilities.h>
#include <XPLMProcessing.h>

#include <cstdio>
#include <cstring>
#include <cstdarg>

//------------------------------------------------------------------------------

using xplra::ListenThread;

//------------------------------------------------------------------------------

static ListenThread* listenThread = 0;

//------------------------------------------------------------------------------

static void debug(const char* format, ...)
{
    va_list ap;
    va_start(ap, format);

    char buf[256];
    vsnprintf(buf, sizeof(buf), format, ap);

    va_end(ap);

    XPLMDebugString(buf);
}

PLUGIN_API int XPluginStart(char* outName, char* outSignature,
                            char* outDescription)
{
    debug("hu.varadiistvan.xplra called\n");

    strcpy(outName, "X-Plane Remote Access");
    strcpy(outSignature, "hu.varadiistvan.xplra");
    strcpy(outDescription, "Provides remote access to datarefs");

    return 1;
}

// float callback(float elapsedSinceLastCall, float elapsedTimeSinceLastFlightLoop,
//               int counter, void* refcon)
// {
//     debug("hu.varadiistvan.proba.callback called: elapsedSinceLastCall=%f, elapsedTimeSinceLastFlightLoop=%f, counter=%d, refcon=%p\n",
//           elapsedSinceLastCall, elapsedTimeSinceLastFlightLoop,
//           counter, refcon);
//     return 5.0;
// }

PLUGIN_API void XPluginEnable(void)
{
    debug("hu.varadiistvan.proba.XPluginEnable called\n");
    // XPLMRegisterFlightLoopCallback(&callback, 5.0, 0);
    listenThread = new ListenThread();
    listenThread->start();
}

PLUGIN_API void XPluginReceiveMessage(XPLMPluginID inFrom, long inMessage,
                                      void* inParam)
{
    debug("hu.varadiistvan.proba.XPluginReceiveMessage called, inFrom=%d, inMessage=%ld, inParam=%p\n",
          inFrom, inMessage, inParam);
}

PLUGIN_API void XPluginDisable(void)
{
    debug("hu.varadiistvan.proba.XPluginDisable called\n");
    // XPLMUnregisterFlightLoopCallback(&callback, 0);
    if (listenThread!=0) {
        listenThread->quit();
        listenThread = 0;
    }
}

PLUGIN_API void XPluginStop(void)
{
    debug("hu.varadiistvan.proba.XPluginStop called\n");
}
